package f5

type goDbPool struct {
	dbPool
}

func (this *goDbPool) init(style DBStyle) {
	this.dbPool.init(style)
}

func (this *goDbPool) unInit() {
	this.dbPool.unInit()
}

func (this *goDbPool) NewOrmSelect(
	dataSource string,
	tblName string,
	whereKv [][]string) (error, *DataSet) {
	var resultErr error
	var resultDs *DataSet
	this.OrmSelect(
		dataSource,
		tblName,
		whereKv,
		func (err error, ds *DataSet) {
			resultErr = err
			resultDs = ds
		})
	return resultErr, resultDs
}


func (this *goDbPool) NewUpsert(
	dataSource string,
	tblName string,
	whereKv [][]string,
	updateKv [][]string,
	insertKv [][]string) (error, int64, int64) {
	var resultErr error
	var resultLastInsertId int64
	var resultRowsAffected int64
	this.Upsert(
		dataSource,
		tblName,
		whereKv,
		updateKv,
		insertKv,
		func (err error, lastInsertId int64, rowsAffected int64) {
			resultErr = err
			resultLastInsertId = lastInsertId
			resultRowsAffected = rowsAffected
		})
	return resultErr, resultLastInsertId, resultRowsAffected
}

func (this *dbPool) NewInsert(
	dataSource string,
	tblName string,
	fieldsKv [][]string) (error, int64, int64) {
	var resultErr error
	var resultLastInsertId int64
	var resultRowsAffected int64
	this.Insert(
		dataSource,
		tblName,
		fieldsKv,
		func (err error, lastInsertId int64, rowsAffected int64) {
			resultErr = err
			resultLastInsertId = lastInsertId
			resultRowsAffected = rowsAffected
		})
	return resultErr, resultLastInsertId, resultRowsAffected
}

func (this *dbPool) NewUpdate(
	dataSource string,
	tblName string,
	whereKv [][]string,
	fieldsKv [][]string) (error, int64, int64) {
	var resultErr error
	var resultLastInsertId int64
	var resultRowsAffected int64
	this.Update(
		dataSource,
		tblName,
		whereKv,
		fieldsKv,
		func (err error, lastInsertId int64, rowsAffected int64) {
			resultErr = err
			resultLastInsertId = lastInsertId
			resultRowsAffected = rowsAffected
		})
	return resultErr, resultLastInsertId, resultRowsAffected
}
